<?php

/**
 *  Copyright (C) 2010 - 2016  <Robbyn Gerhardt>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * @package       Webpackages
 * @author        Robbyn Gerhardt
 * @copyright     Copyright (c) 2010 - 2016, Robbyn Gerhardt (http://www.robbyn-gerhardt.de/)
 * @license       http://opensource.org/licenses/MIT	MIT License
 * @link          http://webpackages.de
 * @since         Version 2.0.0
 * @filesource
 */
class installer
{
	/**
	 * Beendet die Installation
	 *
	 * @return void
	 */
	public function finish()
	{
		if(isset($_POST['security_key']) === true)
		{
			$charset			=	filter_var($_POST['charset'], FILTER_SANITIZE_STRING);
			$timezone			=	filter_var($_POST['timezone'], FILTER_SANITIZE_STRING);
			$security_key		=	filter_var($_POST['security_key'], FILTER_SANITIZE_STRING);
			$locale				=	filter_var($_POST['locale'], FILTER_SANITIZE_STRING);
			$default_class		=	filter_var($_POST['default_class'], FILTER_SANITIZE_STRING);
			$default_method		=	filter_var($_POST['default_method'], FILTER_SANITIZE_STRING);
			$error_reporting	=	((isset($_POST['error_reporting']) === true && $_POST['error_reporting'] == 'on') ? 'true' : 'false');
			$session_handler	=	((isset($_POST['session_handler']) === true && $_POST['session_handler'] == 'on') ? 'true' : 'false');
			$mod_rewrite		=	((isset($_POST['mod_rewrite']) === true && $_POST['mod_rewrite'] == 'on') ? 'true' : 'false');

			$driver				=	filter_var($_POST['driver'], FILTER_SANITIZE_STRING);
			$database_memory	=	filter_var($_POST['database_memory'], FILTER_SANITIZE_STRING);
			$database_server	=	filter_var($_POST['database_server'], FILTER_SANITIZE_STRING);
			$database_username	=	filter_var($_POST['database_username'], FILTER_SANITIZE_STRING);
			$database_password	=	filter_var($_POST['database_password'], FILTER_SANITIZE_STRING);
			$database			=	filter_var($_POST['database'], FILTER_SANITIZE_STRING);
			$database_port		=	filter_var($_POST['database_port'], FILTER_SANITIZE_NUMBER_INT);
			$database_charset	=	filter_var($_POST['database_charset'], FILTER_SANITIZE_STRING);

			if($driver == 'sqlite' || $driver == 'sqlite2')
			{
				$database			=	$database_memory;
				$database_server	=	'';
				$database_username	=	'';
				$database_password	=	'';
				$database_port		=	0;
			}

			if(empty($default_class) === true)
			{
				$default_class	=	'welcome';
			}

			if(empty($default_method) === true)
			{
				$default_method	=	'hello';
			}

			if(empty($security_key) === false && strlen($security_key) >= 20)
			{
				if($session_handler == 'false' || ($session_handler == 'true' && empty($driver) === false && empty($database) === false))
				{
					if(empty($driver) === false && empty($database) === true)
					{
						$error	=	'Bitte füllen Sie alle Datenbankfelder aus!';
					}
					else
					{
						//Beginnen alles in die Kostante zu schreiben
						$constants	=	__DIR__.DIRECTORY_SEPARATOR.'webpackages'.DIRECTORY_SEPARATOR.'constants.php';

						if(file_exists($constants) === true)
						{
							$inConstants	=	file_get_contents($constants);

							$inConstants	=	preg_replace("/define\\('CHARSET',\\s'(.*?)'\\)/m", "define('CHARSET', '".$charset."')", $inConstants);
							$inConstants	=	preg_replace("/define\\('ERROR_REPORTING',\\s(.*?)\\)/m", "define('ERROR_REPORTING', ".$error_reporting.")", $inConstants);

							$inConstants	=	preg_replace("/define\\('TIMEZONE',\\s'(.*?)'\\)/m", "define('TIMEZONE', '".$timezone."')", $inConstants);

							$inConstants	=	preg_replace("/define\\('PDO_TYPE',\\s'(.*?)'\\)/m", "define('PDO_TYPE', '".$driver."')", $inConstants);

							$inConstants	=	preg_replace("/define\\('PDO_HOST',\\s'(.*?)'\\)/m", "define('PDO_HOST', '".$database_server."')", $inConstants);

							$inConstants	=	preg_replace("/define\\('PDO_USERNAME',\\s'(.*?)'\\)/m", "define('PDO_USERNAME', '".$database_username."')", $inConstants);

							$inConstants	=	preg_replace("/define\\('PDO_PASSWORD',\\s'(.*?)'\\)/m", "define('PDO_PASSWORD', '".$database_password."')", $inConstants);

							$inConstants	=	preg_replace("/define\\('PDO_DATABASE',\\s'(.*?)'\\)/m", "define('PDO_DATABASE', '".$database."')", $inConstants);

							$inConstants	=	preg_replace("/define\\('PDO_PORT',\\s(.*?)\\)/m", "define('PDO_PORT', ".$database_port.")", $inConstants);

							$inConstants	=	preg_replace("/define\\('PDO_CHARSET',\\s'(.*?)'\\)/m", "define('PDO_CHARSET', '".$database_charset."')", $inConstants);

							$inConstants	=	preg_replace("/define\\('SECURITY_KEY',\\s'(.*?)'\\);/m", "define('SECURITY_KEY', '".$security_key."');", $inConstants);

							$inConstants	=	preg_replace("/define\\('DEFAULT_LANGUAGE',\\s'(.*?)'\\);/m", "define('DEFAULT_LANGUAGE', '".$locale."');", $inConstants);

							$inConstants	=	preg_replace("/define\\('USE_SESSION_SAVE_HANDLER',\\s(.*?)\\);/m", "define('USE_SESSION_SAVE_HANDLER', ".$session_handler.");", $inConstants);

							$inConstants	=	preg_replace("/define\\('USE_MOD_REWRITE',\\s(.*?)\\);/m", "define('USE_MOD_REWRITE', ".$mod_rewrite.");", $inConstants);

							$inConstants	=	preg_replace("/define\\('DEFAULT_CLASS',\\s(.*?)\\);/m", "define('DEFAULT_CLASS', '".$default_class."');", $inConstants);

							$inConstants	=	preg_replace("/define\\('DEFAULT_METHODE',\\s(.*?)\\);/m", "define('DEFAULT_METHODE', '".$default_method."');", $inConstants);

							file_put_contents($constants, $inConstants);

							$welcomeClass		=	__DIR__.DIRECTORY_SEPARATOR.'webpackages'.DIRECTORY_SEPARATOR.'package'.DIRECTORY_SEPARATOR.'controllers'.DIRECTORY_SEPARATOR.'welcome.class.php';
							$welcomeClassNew	=	__DIR__.DIRECTORY_SEPARATOR.'webpackages'.DIRECTORY_SEPARATOR.'package'.DIRECTORY_SEPARATOR.'controllers'.DIRECTORY_SEPARATOR.$default_class.'.class.php';

							$inWelcomeClass	=	file_get_contents($welcomeClass);

							$inWelcomeClass	=	preg_replace('/class (.*?) extends load_functions/m', 'class '.$default_class.' extends load_functions', $inWelcomeClass);

							$inWelcomeClass	=	str_replace("public function hello()", 'public function '.$default_method.'()', $inWelcomeClass);

							file_put_contents($welcomeClassNew, $inWelcomeClass);

							if($welcomeClassNew != $welcomeClass)
							{
								unlink($welcomeClass);
							}

							$this->moveWebpackagesFolder();
						}
					}
				}
				else
				{
					$error	=	'Wenn Sie Sessions in der Datenbank abspeichern wollen, füllen Sie alle Datenbank Felder aus!';
				}
			}
			else
			{
				$error	=	'Der Sicherheitsschlüssel muss aus mindestens 20 Zeichen bestehen.';
			}
		}

		if(file_exists(__DIR__.DIRECTORY_SEPARATOR.'webpackages.zip') === true)
		{
			$this->step3(false, $error);
		}
		else
		{
			$this->step3(true, $error);
		}
	}

	/**
	 * Verschiebt den webpackages Ordner ins Installer Verzeichnis
	 *
	 * @return void
	 */
	private function moveWebpackagesFolder()
	{
		//Alles alte löschen

		//Template verzeichnis löschen
		$templateDir	=	new RecursiveDirectoryIterator(__DIR__.DIRECTORY_SEPARATOR.'template', RecursiveDirectoryIterator::SKIP_DOTS);
		$iterator		=	new RecursiveIteratorIterator($templateDir, RecursiveIteratorIterator::CHILD_FIRST);

		foreach($iterator as $file)
		{
			if($file instanceof SplFileInfo)
			{
				if($file->isFile() === true)
				{
					unlink($file->__toString());
				}
				else
				{
					rmdir($file->__toString());
				}
			}
		}

		//Index löschen
		unlink(__DIR__.DIRECTORY_SEPARATOR.'index.php');

		$webpackagesDir	=	new RecursiveDirectoryIterator(__DIR__.DIRECTORY_SEPARATOR.'webpackages'.DIRECTORY_SEPARATOR, RecursiveDirectoryIterator::SKIP_DOTS);
		$iterator		=	new RecursiveIteratorIterator($webpackagesDir, RecursiveIteratorIterator::CHILD_FIRST);

		foreach($iterator as $file)
		{
			if($file instanceof SplFileInfo && $file->isFile() === true)
			{
				$path		=	$file->__toString();
				$newPath	=	new SplFileInfo(str_replace('webpackages'.DIRECTORY_SEPARATOR, '', $path));

				if(file_exists($newPath->getPath()) === false)
				{
					mkdir($newPath->getPath(), 0755, true);
				}

				rename($path, $newPath->__toString());
			}
			else
			{
				rmdir($file->__toString());
			}
		}

		rmdir(__DIR__.DIRECTORY_SEPARATOR.'webpackages'.DIRECTORY_SEPARATOR);
		unlink(__DIR__.DIRECTORY_SEPARATOR.'webpackages.zip');
		unlink(__DIR__.DIRECTORY_SEPARATOR.'installer.php');

		header('Location: '.HTTP);
	}


	/**
	 * Überprüfung
	 *
	 * @return void
	 */
	public function step3($isDisabled = true, $error = '')
	{
		if(isset($_POST['serial']) === true)
		{
			$url	=	'http://www.webpackages.de/autorisation.php';

			$data	=	$this->getData($url, array());

			if(file_put_contents('webpackages.zip', $data) !== false)
			{
				$zipArchive	=	new ZipArchive();

				if($zipArchive->open(__DIR__.DIRECTORY_SEPARATOR.'webpackages.zip') === true)
				{
					if($zipArchive->extractTo(__DIR__.DIRECTORY_SEPARATOR.'webpackages') === true)
					{
						$isDisabled	=	false;
					}
					else
					{
						$error	=	'Es trat ein Fehler beim entpacken auf, bitte versuchen Sie es erneut!';
					}
				}
				else
				{
					$error	=	'Das Produkt konnte nicht entpackt werden. Fehlende Schreibrechte.';
				}
			}
			else
			{
				$error	=	'Das Produkt konnte nicht auf den Webserver abgespeichert werden. Fehlende Schreibrechte.';
			}
		}

		require_once __DIR__.DIRECTORY_SEPARATOR.'template'.DIRECTORY_SEPARATOR.'step3.php';
	}

	/**
	 * Sendet eine cURL Anfrage
	 *
	 * @param string $url
	 * @param array $postfields
	 *
	 * @return mixed
	 */
	private function getData($url, $postfields)
	{
		$curl = curl_init();

		curl_setopt($curl, CURLOPT_ENCODING, 'gzip,deflate');
		curl_setopt($curl, CURLOPT_AUTOREFERER, 1);
		curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 120);
		curl_setopt($curl, CURLOPT_TIMEOUT, 120);
		curl_setopt($curl, CURLOPT_URL, $url);
		curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($curl, CURLOPT_MAXREDIRS, 9);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_HEADER, 0);
		curl_setopt($curl, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36');
		curl_setopt($curl, CURLOPT_VERBOSE, true);
		curl_setopt($curl, CURLINFO_HEADER_OUT, true);

		if(empty($postfields) === false)
		{
			curl_setopt($curl, CURLOPT_POST, true);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $postfields);
		}

		$data = curl_exec($curl);
		curl_close($curl);

		return $data;
	}

	/**
	 * Überprüfung
	 *
	 * @return void
	 */
	public function step2()
	{
		require_once __DIR__.DIRECTORY_SEPARATOR.'template'.DIRECTORY_SEPARATOR.'step2.php';
	}

	/**
	 * Überprüfung
	 *
	 * @return void
	 */
	public function step1()
	{
		require_once __DIR__.DIRECTORY_SEPARATOR.'template'.DIRECTORY_SEPARATOR.'step1.php';
	}
}