<?php
$isDisabled	=	'';

$curl_exists				=	function_exists('curl_init');
$gdlib_exists				=	function_exists('imagecreatetruecolor');
$easter_days_exists			=	function_exists('easter_days');
$cal_days_in_month_exists	=	function_exists('cal_days_in_month');
$finfo_exists				=	function_exists('finfo_open');
$hash_exists				=	function_exists('hash_hmac');
$apache_get_modules_exists	=	function_exists('apache_get_modules');
$textdomain					=	function_exists('textdomain');


$SessionHandlerInterface	=	interface_exists('SessionHandlerInterface');
$DateTime					=	class_exists('DateTime');
$SplFileInfo				=	class_exists('SplFileInfo');
$ZipArchive					=	class_exists('ZipArchive');
$pdo						=	class_exists('PDO');
$ResourceBundle				=	class_exists('ResourceBundle');

$driver	=	'';

if($pdo === true)
{
	$driver	=	'('.implode(',', PDO::getAvailableDrivers()).')';
}

$php_version				=	PHP_VERSION;
$php_version_diff			=	(version_compare($php_version, '5.3.0') >= 0);

if($php_version_diff === false || $SplFileInfo === false || $ZipArchive === false)
{
	$isDisabled	=	' disabled';
}
?>

<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
	<title>webpackages Installer - Validieren des Servers</title>

	<!-- Latest compiled and minified CSS -->
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css"
		  integrity="sha384-1q8mTJOASx8j1Au+a5WDVnPi2lkFfwwEAa8hDDdjZlpLegxhjVME1fgjWPGmkzs7" crossorigin="anonymous">

	<!-- Optional theme -->
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap-theme.min.css"
		  integrity="sha384-fLW2N01lMqjakBkx3l/M9EahuwpSfeNvV63J5ezn3uZzapT0u7EYsXMjQV+0En5r" crossorigin="anonymous">

	<!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
	<!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
	<!--[if lt IE 9]>
	<script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
	<script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
	<![endif]-->
	<style>
		.bg {
			background-color: #f8f8f8;
			border: 1px solid #f0f0f0;
			border-radius: 5px;
			-moz-border-radius: 5px;
			-webkit-border-radius: 5px;
			margin-top: 20px;
			padding: 10px;
			margin-bottom: 20px;
		}

		* {
			font-family: "Helvetica Neue", Helvetica, Arial, sans-serif;
			color: #666666;
		}

		html, body {
			background-color: #fefefe;;
		}
	</style>
</head>
<body>

<div class="container">
	<div class="row bg">
		<div class="col-md-12 text-center">
			<a href="http://www.webpackages.de" target="_blank"><img
					src="http://webpackages.de/package/views/kit/img/logo.svg" style="max-width: 200px;"></a>
		</div>

		<div class="col-md-1">&nbsp;</div>
		<div class="col-md-10">
			<h2>Validieren des Servers</h2>
			<p>Um Ihnen ein perfektes Framework an die Hand geben zu können, müssen ein paar Funktionen / Erweiterungen
				auf Ihrem Webserver vorinstalliert sein. Einige dieser Erweiterungen liefert PHP standardmäßig mit,
				ander wiederum sind nicht zwingend Notwendig und sollten nur der Vollständigkeit halber installiert
				sein.</p>
			<br>
			<div class="table-responsive">
				<table class="table table-bordered table-striped">
					<thead>
						<tr>
							<th>Erweiterung / Funktion</th>
							<th>Status</th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<td>cURL</td>
							<td><span class="label label-<?php echo ($curl_exists) ? 'success' : 'warning'; ?>"><?php echo ($curl_exists) ? 'Vorhanden' : 'Nicht vorhanden'; ?></span></td>
						</tr>
						<tr>
							<td>GDLib</td>
							<td><span class="label label-<?php echo ($gdlib_exists) ? 'success' : 'warning'; ?>"><?php echo ($gdlib_exists) ? 'Vorhanden' : 'Nicht vorhanden'; ?></span></td>
						</tr>
						<tr>
							<td>easter_days() Function</td>
							<td><span class="label label-<?php echo ($easter_days_exists) ? 'success' : 'warning'; ?>"><?php echo ($easter_days_exists) ? 'Vorhanden' : 'Nicht vorhanden'; ?></span></td>
						</tr>
						<tr>
							<td>cal_days_in_month() Function</td>
							<td><span class="label label-<?php echo ($cal_days_in_month_exists) ? 'success' : 'warning'; ?>"><?php echo ($cal_days_in_month_exists) ? 'Vorhanden' : 'Nicht vorhanden'; ?></span></td>
						</tr>
						<tr>
							<td>Fileinfo</td>
							<td><span class="label label-<?php echo ($finfo_exists) ? 'success' : 'warning'; ?>"><?php echo ($finfo_exists) ? 'Vorhanden' : 'Nicht vorhanden'; ?></span></td>
						</tr>
						<tr>
							<td>hash_hmac() Function</td>
							<td><span class="label label-<?php echo ($hash_exists) ? 'success' : 'warning'; ?>"><?php echo ($hash_exists) ? 'Vorhanden' : 'Nicht vorhanden'; ?></span></td>
						</tr>
						<tr>
							<td>apache_get_modules() Function</td>
							<td><span class="label label-<?php echo ($apache_get_modules_exists) ? 'success' : 'warning'; ?>"><?php echo ($apache_get_modules_exists) ? 'Vorhanden' : 'Nicht vorhanden'; ?></span></td>
						</tr>
						<tr>
							<td>Gettext Extension</td>
							<td><span class="label label-<?php echo ($textdomain) ? 'success' : 'warning'; ?>"><?php echo ($textdomain) ? 'Vorhanden' : 'Nicht vorhanden'; ?></span></td>
						</tr>
						<tr>
							<td>SessionHandlerInterface Class</td>
							<td><span class="label label-<?php echo ($SessionHandlerInterface) ? 'success' : 'warning'; ?>"><?php echo ($SessionHandlerInterface) ? 'Vorhanden' : 'Nicht vorhanden'; ?></span></td>
						</tr>
						<tr>
							<td>DateTime Class</td>
							<td><span class="label label-<?php echo ($DateTime) ? 'success' : 'warning'; ?>"><?php echo ($DateTime) ? 'Vorhanden' : 'Nicht vorhanden'; ?></span></td>
						</tr>
						<tr>
							<td>SplFileInfo Class</td>
							<td><span class="label label-<?php echo ($SplFileInfo) ? 'success' : 'danger'; ?>"><?php echo ($SplFileInfo) ? 'Vorhanden' : 'Nicht vorhanden'; ?></span></td>
						</tr>
						<tr>
							<td>ZipArchive Class</td>
							<td><span class="label label-<?php echo ($ZipArchive) ? 'success' : 'danger'; ?>"><?php echo ($ZipArchive) ? 'Vorhanden' : 'Nicht vorhanden'; ?></span></td>
						</tr>
						<tr>
							<td>PHP Version >= 5.3.0</td>
							<td><span class="label label-<?php echo ($php_version_diff) ? 'success' : 'danger'; ?>"><?php echo $php_version; ?></span></td>
						</tr>
						<tr>
							<td>PDO Class <?php echo $driver; ?></td>
							<td><span class="label label-<?php echo ($pdo) ? 'success' : 'warning'; ?>"><?php echo ($pdo) ? 'Vorhanden' : 'Nicht vorhanden'; ?></span></td>
						</tr>
						<tr>
							<td>ResourceBundle Class</td>
							<td><span class="label label-<?php echo ($ResourceBundle) ? 'success' : 'warning'; ?>"><?php echo ($ResourceBundle) ? 'Vorhanden' : 'Nicht vorhanden'; ?></span></td>
						</tr>
					</tbody>
				</table>
			</div>

			<div class="col-md-6">
				<a href="<?php echo HTTP; ?>" class="btn btn-warning">Zurück</a>
			</div>
			<div class="col-md-6 text-right">
				<a<?php echo $isDisabled; ?> <?php if($isDisabled == ''){ ?>href="<?php echo HTTP ?>index.php?c=installer&m=step3"<?php } ?> class="btn btn-success">Weiter</a>
			</div>

		</div>
		<div class="col-md-1">&nbsp;</div>

	</div>
</div>


<!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script>
<!-- Include all compiled plugins (below), or include individual files as needed -->
<!-- Latest compiled and minified JavaScript -->
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js"
		integrity="sha384-0mSbJDEHialfmuBBQP6A4Qrprq5OVfW37PRR3j5ELqxss1yVqOtnepnHVP9aJ7xS"
		crossorigin="anonymous"></script>
</body>
</html>