<?php
if(function_exists('apache_get_modules') && in_array('mod_rewrite', apache_get_modules()))
{
	$mod_rewrite = true;
}
elseif(isset($_SERVER['IIS_UrlRewriteModule']))
{
	$mod_rewrite = true;
}
else
{
	$mod_rewrite = false;
}
?>
<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
	<title>webpackages Installer - Validieren des Servers</title>

	<!-- Latest compiled and minified CSS -->
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css"
		  integrity="sha384-1q8mTJOASx8j1Au+a5WDVnPi2lkFfwwEAa8hDDdjZlpLegxhjVME1fgjWPGmkzs7" crossorigin="anonymous">

	<!-- Optional theme -->
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap-theme.min.css"
		  integrity="sha384-fLW2N01lMqjakBkx3l/M9EahuwpSfeNvV63J5ezn3uZzapT0u7EYsXMjQV+0En5r" crossorigin="anonymous">

	<!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
	<!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
	<!--[if lt IE 9]>
	<script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
	<script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
	<![endif]-->
	<style>
		.bg {
			background-color: #f8f8f8;
			border: 1px solid #f0f0f0;
			border-radius: 5px;
			-moz-border-radius: 5px;
			-webkit-border-radius: 5px;
			margin-top: 20px;
			padding: 10px;
			margin-bottom: 20px;
		}

		p {
			font-family: "Helvetica Neue", Helvetica, Arial, sans-serif;
			color: #666666;
		}

		html, body {
			background-color: #fefefe;;
		}
	</style>
</head>
<body>

<div class="container">
	<div class="row bg">
		<div class="col-md-12 text-center">
			<a href="http://www.webpackages.de" target="_blank"><img
					src="http://webpackages.de/package/views/kit/img/logo.svg" style="max-width: 200px;"></a>
		</div>

		<div class="col-md-1">&nbsp;</div>
		<?php
		if($isDisabled === true)
		{
			?>
			<div class="col-md-10">
				<h2>Installation</h2>
				<p>Die Installation kann nun beginnen, bitte klicken Sie unten auf den Button Herunterladen um das aktuellste wepackages Frameworks, auf Ihren Server zu laden.</p>

				<?php
				if(empty($error) === false)
				{
					echo '
				<div class="alert alert-danger">
				  <strong>Fehler!</strong> '.$error.'
				</div>
				';
				}
				?>
				<form role="form" action="<?php echo HTTP; ?>index.php?c=installer&m=step3" method="POST">
					<div class="col-md-6">
						<a href="<?php echo HTTP; ?>index.php?c=installer&m=step2" class="btn btn-warning">Zurück</a>
					</div>
					<div class="col-md-6 text-right">
						<input type="hidden" name="serial">
						<button type="submit" class="btn btn-success">Herunterladen</button>
					</div>
				</form>
				<br>
			</div>
			<?php
		}
		else
		{
			?>
			<div class="col-md-10">
				<h2>Letzter Schritt</h2>
				<p>Bitte füllen Sie die unteren Felder aus. Datenbank Daten geben Sie bitte nur ein, wenn auch eine
					Datenbankverbindung aufgebaut werden soll.</p>

				<?php
				if(empty($error) === false)
				{
					echo '
				<div class="alert alert-danger">
				  <strong>Fehler!</strong> '.$error.'
				</div>
				';
				}
				?>


				<form role="form" action="<?php echo HTTP; ?>index.php?c=installer&m=finish" method="POST">
					<h3>Informationen
						<small><span class="glyphicon glyphicon-question-sign" data-toggle="tooltip" data-placement="right"
									 title="Diese Informationen werden zur eindeutigen Identifizierung, Anonym, an die webpackages Server gesendet, um Ihren Server zu autorisieren."></span>
						</small>
					</h3>
					<div class="row">
						<div class="col-md-2">
							<strong>Betriebssystem</strong><br>
							<small><?php echo PHP_OS; ?></small>
						</div>
						<div class="col-md-2">
							<strong>Server Protokoll</strong><br>
							<small><?php echo $_SERVER['SERVER_PROTOCOL']; ?></small>
						</div>
						<div class="col-md-2">
							<strong>Server Name</strong><br>
							<small><?php echo $_SERVER['SERVER_NAME']; ?></small>
						</div>
						<div class="col-md-2">
							<strong>Server IP</strong><br>
							<small><?php echo $_SERVER['SERVER_ADDR']; ?></small>
						</div>
						<div class="col-md-2">
							<strong>Webserver</strong><br>
							<small><?php echo $_SERVER['SERVER_SOFTWARE']; ?></small>
						</div>
						<div class="col-md-2">
							<strong>CGI Version</strong><br>
							<small><?php echo $_SERVER['GATEWAY_INTERFACE']; ?></small>
						</div>
					</div>
					<br>
					<div class="row">
						<div class="col-md-2">
							<strong>PHP Version</strong><br>
							<small><?php echo PHP_VERSION; ?></small>
						</div>
						<div class="col-md-2">
							<strong>PDO Treiber</strong><br>
							<small><?php echo implode(',', PDO::getAvailableDrivers()); ?></small>
						</div>
					</div>
					<br>
					<h3>Allgemein</h3>
					<div class="form-group">
						<label for="serial">Zeichenkodierung <small><span class="glyphicon glyphicon-question-sign" data-toggle="tooltip" data-placement="right" title="Die Zeichenkodierung oder Buchstabenkodierung, dient zur richtigen Darstellung von Zeichen im Framework"></span></small></label>
						<select class="form-control" name="charset">
							<?php
							$allCharsets = array(
								'UCS-4',
								'UCS-4BE',
								'UCS-4LE',
								'UCS-2',
								'UCS-2BE',
								'UCS-2LE',
								'UTF-32',
								'UTF-32BE',
								'UTF-32LE',
								'UTF-16',
								'UTF-16BE',
								'UTF-16LE',
								'UTF-7',
								'UTF7-IMAP',
								'UTF-8',
								'ASCII',
								'EUC-JP',
								'SJIS',
								'eucJP-win',
								'SJIS-win',
								'ISO-2022-JP',
								'ISO-2022-JP-MS',
								'CP932',
								'CP51932',
								'JIS',
								'JIS-ms',
								'CP50220',
								'CP50220raw',
								'CP50221',
								'CP50222',
								'ISO-8859-1',
								'ISO-8859-2',
								'ISO-8859-3',
								'ISO-8859-4',
								'ISO-8859-5',
								'ISO-8859-6',
								'ISO-8859-7',
								'ISO-8859-8',
								'ISO-8859-9',
								'ISO-8859-10',
								'ISO-8859-13',
								'ISO-8859-14',
								'ISO-8859-15',
								'byte2be',
								'byte2le',
								'byte4be',
								'byte4le',
								'BASE64',
								'HTML-ENTITIES',
								'7bit',
								'8bit',
								'EUC-CN',
								'CP936',
								'HZ',
								'EUC-TW',
								'CP950',
								'BIG-5',
								'EUC-KR',
								'UHC',
								'ISO-2022-KR',
								'Windows-1251',
								'Windows-1252',
								'CP866',
								'KOI8-R',
								'ArmSCII-8'
							);

							foreach($allCharsets as $charset)
							{
								echo '<option value="'.$charset.'"'.(($charset == 'UTF-8') ? ' selected' : '').'>'.$charset.'</option>';
							}
							?>
						</select>
					</div>
					<div class="form-group">
						<label for="serial">Zeitzone <small><span class="glyphicon glyphicon-question-sign" data-toggle="tooltip" data-placement="right" title="Mithilfe der Zeitzone können Berechnung mit Zeitstempeln präziser vorgenommen werden."></span></small></label>
						<select class="form-control" name="timezone">
							<?php
							$defaultTimezone = date_default_timezone_get();

							if(empty($defaultTimezone) === true)
							{
								$defaultTimezone = 'Europe/Berlin';
							}

							foreach(timezone_identifiers_list() as $timezone)
							{
								echo '<option value="'.$timezone.'"'.(($defaultTimezone == $timezone) ? ' selected' : '').'>'.$timezone.'</option>';
							}
							?>
						</select>
					</div>
					<div class="form-group">
						<label for="security_key">Sicherheitsschlüssel*
							<small><span class="glyphicon glyphicon-question-sign" data-toggle="tooltip" data-placement="right" title="Mit dem Sicherheitsschlüssel werden Verschlüsselungen im System vorgenommen. Er sollte eindeutig sein und aus mindestens 20 Zeichen bestehen."></span></small>
							<small>(min. 20 Zeichen)</small>
						</label>
						<input type="text" class="form-control" min="20"
							   value="<?php echo sha1(uniqid(mt_rand(), true)); ?>" id="security_key"
							   name="security_key">
					</div>
					<div class="form-group">
						<label for="default_class">Standard Klasse beim Aufruf der index.php <small><span class="glyphicon glyphicon-question-sign" data-toggle="tooltip" data-placement="right" title="Beim Aufruf der index.php des webpackages Frameworks, ohne Parameter, muss eine Standard Klasse aufgerufen werden."></span></small>
						</label>
						<input type="text" class="form-control" name="default_class" id="default_class" value="welcome">
					</div>
					<div class="form-group">
						<label for="default_method">Standard Methode beim Aufruf der index.php <small><span class="glyphicon glyphicon-question-sign" data-toggle="tooltip" data-placement="right" title="Beim Aufruf der index.php des webpackages Frameworks, ohne Parameter, muss eine Standard Methode in einer Standard Klasse aufgerufen werden."></span></small>
						</label>
						<input type="text" class="form-control" name="default_method" id="default_method" value="hello">
					</div>
					<div class="form-group">
						<label for="security_key">Standard Sprach-Locale <small><span class="glyphicon glyphicon-question-sign" data-toggle="tooltip" data-placement="right" title="Um das Webprojekt einer eindeutigen Sprache und Region zuzuweisen, sollte man hier das Locale auswählen was am besten zu dem Webprojekt passt."></span></small></label>
						<?php
						if(class_exists('ResourceBundle') === true)
						{
							echo '
						<select class="form-control" name="locale">
						';

							$defaultLocale = 'en_US';

							if(function_exists('locale_get_default') === true)
							{
								$defaultLocale = locale_get_default();
							}

							foreach(ResourceBundle::getLocales('') as $bundle)
							{
								echo '<option value="'.$bundle.'"'.(($bundle == $defaultLocale) ? ' selected' : '').'>'.$bundle.'</option>';
							}

							echo '
						</select>
						';
						}
						else
						{
							echo '<input type="text" class="form-control" name="locale" value="en_US" id="locale">';
						}
						?>
					</div>

					<div class="checkbox">
						<label><input type="checkbox" name="error_reporting" checked> Entwickler Modus
							aktivieren</label>
					</div>

					<div class="checkbox">
						<label><input type="checkbox" name="session_handler"<?php echo (interface_exists('SessionHandlerInterface') === false) ? ' disabled' : ''; ?>> Sessions in Datenbank abspeichern<?php echo (interface_exists('SessionHandlerInterface') === false) ? ' <small class="text-danger">(Auf Ihrem Server ist SessionHandlerInterface nicht installiert)</small>' : ''; ?></label>
					</div>

					<div class="checkbox">
						<label><input type="checkbox" name="mod_rewrite"<?php echo ($mod_rewrite) ? ' checked' : ''; ?>>
							Benutzerfreundliche URL's
							(mod_rewrite)<?php echo (function_exists('apache_get_modules') === false) ? ' <small class="text-warning">(Es konnte nicht analysiert werden ob Sie mod_rewrite installiert haben)</small>' : ''; ?></label>
					</div>

					<br>
					<h3>Datenbank</h3>
					<div class="form-group">
						<label for="serial">Datenbank Treiber</label>
						<select name="driver" id="driver" class="form-control">
							<?php
							echo '<option value="">Keine Datenbankverbindung</option>';
							foreach(PDO::getAvailableDrivers() as $driver)
							{
								echo '<option value="'.$driver.'">'.$driver.'</option>';
							}
							?>
						</select>
					</div>

					<div class="form-group sqlite">
						<label for="database_memory">Datenbank Datei / Memory</label>
						<input type="text" class="form-control" id="database_memory" name="database_memory">
					</div>

					<div class="form-group mysql">
						<label for="database_server">Datenbank Server</label>
						<input type="text" class="form-control" id="database_server" name="database_server">
					</div>

					<div class="form-group mysql">
						<label for="database_username">Datenbank Benutzername</label>
						<input type="text" class="form-control" id="database_username" name="database_username">
					</div>

					<div class="form-group mysql">
						<label for="database_password">Datenbank Passwort</label>
						<input type="password" class="form-control" id="database_password" name="database_password">
					</div>

					<div class="form-group mysql">
						<label for="database">Datenbank Name</label>
						<input type="text" class="form-control" id="database" name="database">
					</div>

					<div class="form-group mysql">
						<label for="database_port">Datenbank Port</label>
						<input type="text" class="form-control" id="database_port" value="3306" name="database_port">
					</div>

					<div class="form-group mysql">
						<label for="database_charset">Datenbank Zeichenkodierung</label>
						<input type="text" class="form-control" id="database_charset" value="utf8"
							   name="database_charset">
					</div>

					<div class="col-md-6">
						<a href="<?php echo HTTP; ?>index.php?c=installer&m=step3" class="btn btn-warning">Zurück</a>
					</div>
					<div class="col-md-6 text-right">
						<button type="submit" class="btn btn-success">Installation beenden</button>
					</div>
				</form>
			</div>
			<?php
		}
		?>
		<div class="col-md-1">&nbsp;</div>

	</div>
</div>


<!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script>
<!-- Include all compiled plugins (below), or include individual files as needed -->
<!-- Latest compiled and minified JavaScript -->
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js"
		integrity="sha384-0mSbJDEHialfmuBBQP6A4Qrprq5OVfW37PRR3j5ELqxss1yVqOtnepnHVP9aJ7xS"
		crossorigin="anonymous"></script>

<script>
	$(document).ready(function () {
		$('[data-toggle="tooltip"]').tooltip();

		$('#driver').change(function(){
			if($(this).val() == '')
			{
				$('#database_server').prop('disabled', 'disabled');
				$('#database_username').prop('disabled', 'disabled');
				$('#database_password').prop('disabled', 'disabled');
				$('#database').prop('disabled', 'disabled');
				$('#database_port').prop('disabled', 'disabled');
				$('#database_charset').prop('disabled', 'disabled');
				$('#database_memory').prop('disabled', 'disabled');
			}
			else
			{
				$('#database_server').removeProp('disabled');
				$('#database_username').removeProp('disabled');
				$('#database_password').removeProp('disabled');
				$('#database').removeProp('disabled');
				$('#database_port').removeProp('disabled');
				$('#database_charset').removeProp('disabled');
				$('#database_memory').removeProp('disabled');
			}

			if($(this).val() != 'sqlite' && $(this).val() != 'sqlite2')
			{
				$('.mysql').show()
				$('.sqlite').hide();
			}
			else
			{
				$('.mysql').hide()
				$('.sqlite').show();
			}
		});

		$('#driver').change();
	});
</script>
</body>
</html>